;
;  室
;
CmdTab:
 dw	Init		; init			 0
 dw	MediaCheck	; media_check		 1
 dw	BuildBPB	; get_bpb		 2
 dw	msg8003		; ioctl_input		 3
 dw	Input		; input			 4
 dw	msg0200		; nd_input		 5   訢 ????
 dw	msg0000		; input_status		 6
 dw	msg0000		; input_flush		 7
 dw	OutputNoVer	; output		 8
 dw	OutputVer	; output_verify		 9
 dw	msg0000		; output_status		10
 dw	msg0000		; output_flush		11
 dw	msg8003		; ioctl_out		12
 dw	Open		; open			13
 dw	Close		; close			14
 dw	msg0000		; removable		15 ** 0200 - non removable, 0000 - removable
; dw	msg8003		; output_busy ????	16
; dw	msg8003		;			17
; dw	msg8003		;			18
; dw	msg8003		; Genmsgic IOCtrl	19
; dw	msg8003		;			20
; dw	msg8003		;			21
; dw	msg8003		;			22
; dw	msg8003		; Get Logical Device	23
; dw	msg8003		; Set Logical Device	24
; else msg8003

; 0   write protect violation           9   printer out of paper
; 1   unknown unit                     0aH  write fault
; 2   device not ready                 0bH  read fault
; 3   unknown command                  0cH  general failure
; 4   CRC error                        0dH  (reserved)
; 5   bad request structure length     0eH  (reserved)
; 6   seek error                       0fH  invalid disk change  (DOS 3.0+)
; 7   unknown media
; 8   sector not found

ReqAdr	dd	?	;   
;
;  `⥣'
;
dev_strategy:
 mov	word ptr cs:ReqAdr+2,es
 mov	word ptr cs:ReqAdr+0,bx
 retf
;
;  `뢠'
;
dev_interrupt:
 pushf
 pusha
 push	ds
 push	es

;  
 lds	si,cs:ReqAdr
 mov	[si].rh_status,0100h
 mov	al,[si].rh_unit
 movzx	bx,[si].rh_cmd

;  
 mov	dx,cs:LenLog
 cmp	dx,0			; ds:si -> ReqHead
 je	DI_1			; cs-> Driver memory
 mov	di,cs:MrkLog		; es-> Seg0000

 push	0			; al - Unit
 pop	es			; bl - Request, bh = 0
 mov	ecx,es:046ch            ; ecx - Time
 mov	cs:[di].DynBuffer.sLog_Time,ecx   ; dx - LenLog

 mov	cs:[di].DynBuffer.sLog_Unit,al    ; di - Marker
 mov	cs:[di].DynBuffer.sLog_Req,bl

 movzx	ecx,[si].rh4_start
 cmp	cx,0ffffh
 jnz    DI_3
 mov	ecx,[si].rh4_estart
DI_3:
 mov	cs:[di].DynBuffer.sLog_FrSec,ecx

 mov	cx,[si].rh4_count
 mov	cs:[di].DynBuffer.sLog_NmSec,cx

 add	di,size sLog
 cmp	di,dx
 jb	DI_2
 xor	di,di
DI_2:
 mov	cs:MrkLog,di

DI_1:
; ஫ unit'a
 cmp	al,cs:NumberDev
 ja	DI_InvUnit

;   ⠡ 㪠 unit'a
 movzx	cx,al
 imul	cx,size sDsk_Hd
 add	cx,cs:DskHdAdr
 mov	cs:DskCurHdAdr,cx

; ஫  
 cmp	bl,15
 ja	DI_InvReq

;   ࠡ稪  
 shl	bx,1
 add	bx,offset cmdtab
 push	offset DI_Ret
 jmp	cs:[bx]		; cx = DskCurHdAdr; ds:si -> Request Header

DI_Ret:
 lds	si,cs:ReqAdr
 jmp	done

DI_InvUnit:
 or	[si].rh_status,8001h	; -   or xor, ⮣   㦭 jmp.... ;)))
 jmp	done

DI_InvReq:
 call	msg8003

done:
 pop	es
 pop	ds
 popa
 popf
 retf

msg0200:
 or	[si].rh_status,0200h
 retn
 
msg8003:
 or	[si].rh_status,8003h
msg0000:
 retn
