unit gr4txt;
{ 䨪  ⥪.  ᪮ 256 x 64 }

interface

const
GetMaxX=255;
GetMaxY=63;

procedure SetGraphMode;
procedure ClearDevice;
procedure UpDateDevice;
procedure PutPixel(x,y,z:byte);
procedure DirWrite(const x,y:byte; const s:string);

implementation
const
x0=15;
y0=15;
GraphMode:boolean=false;

type
tfnt=array[0..255,0..15] of Byte; tpFnt=^tFnt;

var
OldExitProc:pointer; fnt:tpFnt;
back:array[y0..y0+7,x0..x0+31] of word;
Screen:array[1..25,1..80] of word absolute $B800:$0000;

procedure DirWrite;
var n:byte;
begin
for n:=1 to length(s) do Screen[y,x+n-1]:=ord(s[n])+$0700;
end;

procedure SetGraphMode;
var x,y,c:byte;
begin
c:=0; GraphMode:=true;
for y:=y0 to y0+7 do
  for x:=x0 to x0+31 do
    begin
      back[y,x]:=Screen[y,x];
      Screen[y,x]:=($0a00 + ((c shl 2) and $0200)) or (c);
      inc(c);
    end;
end;

procedure PutPixel;
const Mask:array[0..7] of byte=($80,$40,$20,$10, $08,$04,$02,$01);
var xOffs,xChar,yOffs,yChar,Char:byte; p:pointer;
begin
if z=1 then inc(y,64);
xOffs:=x and 7;  xChar:=x shr 3;
yOffs:=y and 15; yChar:=y and $f0 shl 1;
Char:=yChar or xChar;
fnt^[Char,yOffs]:=fnt^[Char,yOffs] or Mask[xOffs];
{
p:=@fnt^[Char];
asm
  mov ax,$1100
  mov cx,1
  xor dh,dh
  mov dl,Char
  mov bx,$1001
  push bp
  les bp,p
  int $10
  pop bp
end;
}
end;

{$F+}
procedure CloseGraph;
var x,y:byte;
begin
{$F-}
ExitProc:=OldExitProc;

if GraphMode then
  for y:=y0 to y0+7 do
    for x:=x0 to x0+31 do
      Screen[y,x]:=back[y,x];

asm
  mov ax,$1103
  xor bl,bl
  int $10
end;
end;

procedure ClearDevice;
begin
asm
  xor ax,ax
  mov cx,2048
  cld
  les di,fnt
  rep stosw
end;
end;

procedure UpDateDevice;
begin
asm
  push bp
  mov ax,$1100       {?100}
  mov cx,256
  xor dx,dx
  mov bx,$1001
  les bp,fnt
  int $10
  pop bp
end;
end;

procedure InitGraph;
begin
ClearDevice;
UpDateDevice;
asm
  mov ax,$1103
  mov bl,4
  int $10
end;
end;

begin
new(fnt);
OldExitProc:=ExitProc; ExitProc:=@CloseGraph;
InitGraph;
end.