unit sLink;

interface
uses sDisks;

const
  Drive		: byte=0;

type
  tDskHd=record { ਯ  }
    sDskFlag	: word;    { d3 - Null Write, d2 - Enable Write, d1 - Enable Read, d0 - Was change }
    sDskFile	: word;    { ⢮  䠩 ( ᠬ   ࠡ⠥.  mSoft ) }
    sDskSt	: longint; { 饭 ( ᥪ) ࠧ }
    sDskFn	: longint; { ᫥ ᥪ ࠧ ( 㦥  㯥) }
  end;

  tLogRec=record {   }
    lReq	: byte;
    lUnit	: byte;
    lTime	: longint;
    lFrSec	: longint;
    lNmSec	: word;
  end;

  tDriveData=record { 騩   }
    NumberDev	 : byte;
    StartDev	 : byte;
    Drive	 : byte;
    DirectAcc	 : byte;
    Direct32	 : byte;
    LastReq	 : byte;
    LenLog	 : word;
    MrkLog	 : word;
    DskHdAdr	 : word; { 㪠뢠  ᨢ ⠡ ࠩ }
    DskCurHdAdr	 : word; { 㪠뢠  ⠡ ᫥ ᯮ㥬 ࠩ }
    {;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;}
    tbl_Adr	 : byte; { expect 16 }
    rsv0	 : byte;
    tbl_AdrCount : byte; { max is 127 }
    rsv1	 : byte;
    tbl_AdrAdress: pointer;
    tbl_AdrStartL: longint;
    tbl_AdrStartH: longint; { expect 0 }
    {;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;}
    BPBBuf	 :array[1..BT2SC] of byte;
  end;

  taDskHd	= array[1..32] of tDskHd;
  taLogRec	= array[1..$1000] of tLogRec;

const
  sizeDriveData	= sizeOf(tDriveData);

var
  DriveSeg	: word;
  DDOffset	: word;
  pDriveData	: ^tDriveData;
  paDskHd	: ^taDskHd;
  paLogRec	: ^taLogRec;

function TestDriver:boolean;

implementation

function TestDriver;
var res:byte;
begin
{INT 21h
  In: AH=2Bh CX="SE" DX="VI"
 Out: AL=0 ES:DX=@buffer }
asm
  mov ah,$2b
  mov al,Drive
  mov cx,'SE'
  mov dx,'VI'
  int $21
  cmp ah,Drive
  je  @1
  mov al,255
@1:
  mov res,al
  mov word ptr pDriveData+0,dx
  mov DDOffset,dx
  add dx,sizeDriveData
  mov word ptr paLogRec+0,dx
  mov word ptr pDriveData+2,es
  mov DriveSeg,es
  mov word ptr paLogRec+2,es
end;
paDskHd:=Ptr(DriveSeg,pDriveData^.DskHdAdr);
TestDriver:=res=0;
end;

end.